Subject: Re: P1022 audio driver help!

From: Timur Tabi <[email-masked]>
Date: Fri, 30 May 2014 10:48:33 -0500

On 05/30/2014 01:03 AM, eshe168 wrote:
> @timur
> hi,
> Audio card (wm8776) cannot work in full duplex, CPU is FSL P1022.
> The PCB design about audio card reference FSL P1022 development board,
> and palying or recording is OK separately.
> My question is whether P1022 audio driver cannot support full duplex?

I was never able to get the P1022ds audio to work in full duplex.  After 
trying for a few weeks, I just gave up.

If you look inside fsl_ssi.c (the main driver) you'll see this comment I 
wrote:

/*
  * FIXME: The documentation says that SxCCR[WL] should not be
  * modified while the SSI is enabled.  The only time this can
  * happen is if we're trying to do simultaneous playback and
  * capture in asynchronous mode.  Unfortunately, I have been enable
  * to get that to work at all on the P1022DS.  Therefore, we don't
  * bother to disable/enable the SSI when setting SxCCR[WL], because
  * the SSI will stop anyway.  Maybe one day, this will get fixed.
  */

(it should say "I have been unable" instead of "I have been enable")

Full duplex works fine on the MPC8610, which has the same audio 
controller as the P1022, so I know the controller is physically capable 
of it.  I just don't know why it doesn't work on the P1022DS.  I also 
don't know if it's a problem with the P1022DS board or with the P1022 
SOC itself.